--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), May 2000
--

class ALARM_THREAD

inherit
  THREAD

feature {ALARM_THREAD}

  main is
    local
      alrm: ALARM;
      now: INTEGER;
      expired: BOOLEAN;
    do
      from
        mtx.lock;
      until
        FALSE
      loop
        from
          alrm_lst.set_current_alarm(0);
        until
          not alrm_lst.lst.is_empty
        loop
          cnd_var.wait(mtx)
        end;
        alrm := alrm_lst.lst.item(alrm_lst.lst.lower);
        alrm_lst.lst.remove_first;
        now := get_current_time;
        expired := FALSE;
        if alrm.abstime > now then
          from
            alrm_lst.set_current_alarm(alrm.abstime);
          until
            expired or else alrm_lst.current_alarm /= alrm.abstime
          loop
            if not cnd_var.timedwait(mtx,alrm.abstime) then
              expired := TRUE; -- on timeout
            end;
          end;
          if not expired then
            alrm_lst.insert(alrm)
          end;
        else
          expired := TRUE
        end;
        if expired then
          print_string("(");
          print_integer(alrm.delay);
          print_string(") ");
          print_string(alrm.message);
          print_newline;
        end
      end;
    end;

feature

  mtx: MUTEX;

  cnd_var: CONDITION_VARIABLE;

  alrm_lst: ALARM_LIST;

  set_mutex(m: MUTEX) is
    do
      mtx := m
    end;

  set_cond_var(cv: CONDITION_VARIABLE) is
    do
      cnd_var := cv
    end;

  set_alarm_list(al: ALARM_LIST) is
    do
      alrm_lst := al
    end;

end -- ALARM_THREAD

