--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), May 2000
--

class MAIN

creation
  make

feature

  mtx: MUTEX;

  cnd_var: CONDITION_VARIABLE;

  thr: ALARM_THREAD;

  alrm_lst: ALARM_LIST;

  inp_str_max_size: INTEGER is 64;

  make is
    local
      end_loop: BOOLEAN;
      inp_str: STRING;
      alrm: ALARM;
      delay: INTEGER;
    do
      !!mtx.make;
      !!cnd_var.make;
      !!thr;
      !!alrm_lst.make;
      thr.set_mutex(mtx);
      thr.set_cond_var(cnd_var);
      thr.set_alarm_list(alrm_lst);
      thr.start_detached;
      end_loop := FALSE;
      from
        !!inp_str.make(inp_str_max_size + 1);
      until
        end_loop
      loop
        print_string("Alarm> ");
        delay := get_integer;
        if delay < 0 then
          end_loop := TRUE;
        elseif delay > 0 then
          get_line(inp_str);

--          print_string("Input: (");
--          print_integer(delay);
--          print_string(") ");
--          print_string(inp_str);
--          print_newline;

          !!alrm.make(delay,inp_str);
          mtx.lock;
          alrm_lst.insert(alrm);
          if alrm_lst.current_alarm = 0 or
             alrm.abstime < alrm_lst.current_alarm then
            alrm_lst.set_current_alarm(alrm.abstime);
            cnd_var.signal;
          end;
          mtx.unlock;
        end;
      end;
    end;

end -- MAIN

