--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2003
--

class ONCE_EXAMPLE

inherit
  THREAD

creation
  make

feature {ONCE_EXAMPLE}

  main is
    do
      test_class_thread;
      test_class_process;
      test_object_thread;
      test_object_process;
    end;

  test_class_thread is
    local
      i,j: INTEGER
    do
      class_thread_once_proc(thread_id);
      class_thread_once_proc(thread_id);
      class_thread_once_proc(thread_id);
      i := class_thread_once_func(thread_id);
      j := class_thread_once_func(thread_id);
      check j = i end;
      j := class_thread_once_func(thread_id);
      check j = i end;
    end;

  test_class_process is
    local
      i,j: INTEGER
    do
      class_process_once_proc(thread_id);
      class_process_once_proc(thread_id);
      class_process_once_proc(thread_id);
      i := class_process_once_func(thread_id);
      j := class_process_once_func(thread_id);
      check j = i end;
      j := class_process_once_func(thread_id);
      check j = i end;
    end;

  test_object_thread is
    local
      i,j: INTEGER
    do
      shared_obj1.object_thread_once_proc(thread_id);
      shared_obj1.object_thread_once_proc(thread_id);
      shared_obj1.object_thread_once_proc(thread_id);
      i := shared_obj1.object_thread_once_func(thread_id);
      j := shared_obj1.object_thread_once_func(thread_id);
      check j = i end;
      j := shared_obj1.object_thread_once_func(thread_id);
      check j = i end;

      shared_obj2.object_thread_once_proc(thread_id);
      shared_obj2.object_thread_once_proc(thread_id);
      shared_obj2.object_thread_once_proc(thread_id);
      i := shared_obj2.object_thread_once_func(thread_id);
      j := shared_obj2.object_thread_once_func(thread_id);
      check j = i end;
      j := shared_obj2.object_thread_once_func(thread_id);
      check j = i end;
    end;

  test_object_process is
    local
      i,j: INTEGER
    do
      shared_obj1.object_process_once_proc(thread_id);
      shared_obj1.object_process_once_proc(thread_id);
      shared_obj1.object_process_once_proc(thread_id);
      i := shared_obj1.object_process_once_func(thread_id);
      j := shared_obj1.object_process_once_func(thread_id);
      check j = i end;
      j := shared_obj1.object_process_once_func(thread_id);
      check j = i end;

      shared_obj2.object_process_once_proc(thread_id);
      shared_obj2.object_process_once_proc(thread_id);
      shared_obj2.object_process_once_proc(thread_id);
      i := shared_obj2.object_process_once_func(thread_id);
      j := shared_obj2.object_process_once_func(thread_id);
      check j = i end;
      j := shared_obj2.object_process_once_func(thread_id);
      check j = i end;
    end;

feature

  shared_obj1,shared_obj2: OBJECT_ONCE_EXAMPLE;

  thread_id: INTEGER;

  make(id: INTEGER;obj1,obj2: OBJECT_ONCE_EXAMPLE) is
    do
      thread_id := id;
      shared_obj1 := obj1;
      shared_obj2 := obj2
    end;

  class_thread_once_proc(id: INTEGER) is
    once
      print_integer(id);
      print_string("->class_thread_once_proc:%N");
    end;

  class_thread_once_func(id: INTEGER): INTEGER is
    once
      Result := 3;
      print_integer(id);
      print_string("->class_thread_once_func: ");
      print_string(Result.to_string);
      print_string("%N")
    end;

  class_process_once_proc(id: INTEGER) is
    once {"process"}
      print_integer(id);
      print_string("->class_process_once_proc:%N");
    end;

  class_process_once_func(id: INTEGER): INTEGER is
    once {"process"}
      Result := 7;
      print_integer(id);
      print_string("->class_process_once_func: ");
      print_string(Result.to_string);
      print_string("%N")
    end;

end -- ONCE_EXAMPLE

