--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), October 2000
--

class CONSUMER

inherit
  THREAD

creation
  make

feature {CONSUMER}

  main is
    local
      i: ITEM;
      msg: STRING;
    do
      !!msg.make(80);
      msg.copy("Consumer ");
      msg.append(id.to_string);
      msg.append(" started.");
      print_line(msg);
      barr.sign_on;
      data_mutex.lock;
      from
      until
        data.finish
      loop
        start_cond_var.wait(data_mutex); -- waiting for a start signal
        data.activate_consumer;
        from
        until
          data.empty and not data.production_active
        loop
          cond_var.wait(data_mutex);
          if not data.empty then
            i := data.item;
            data.remove;
            msg.copy(i.str);
            msg.append(" and consumed by ");
            msg.append(id.to_string);
            print_line(msg);
            if not data.empty then
              cond_var.signal;
              data_mutex.unlock;
              us_sleep(1000*random_integer(100));
              data_mutex.lock;
            end
          end
        end;
        data.deactivate_consumer;
        debug
          msg.copy("Consumer ");
          msg.append(id.to_string);
          msg.append(" waiting on barrier...");
          print_line(msg);
        end;
        data_mutex.unlock;
        barr.wait;
        debug
          msg.copy("Consumer ");
          msg.append(id.to_string);
          msg.append(" passed barrier...");
          print_line(msg);
        end;
        data_mutex.lock;
      end;
      data_mutex.unlock;
      msg.copy("Consumer ");
      msg.append(id.to_string);
      msg.append(" finish.");
      print_line(msg);
    end;

feature

  make(tid: INTEGER;dt: SHARED_DATA;mtx: MUTEX;cvar,start_cvar: CONDITION_VARIABLE;brr: THREAD_BARRIER) is
    do
      id := tid;
      data := dt;
      data_mutex := mtx;
      cond_var := cvar;
      start_cond_var := start_cvar;
      barr := brr
    end;

  id: INTEGER;

  data: SHARED_DATA;

  data_mutex: MUTEX;

  cond_var: CONDITION_VARIABLE;

  start_cond_var: CONDITION_VARIABLE;

  barr: THREAD_BARRIER;

end -- CONSUMER

