--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), October 2000
--

class MAIN

inherit
  THREAD_CONTROL

creation
  make

feature

  num_producer_stages: INTEGER is 5;

  num_consumers: INTEGER is 9;

  num_items: INTEGER is 100;

  make is
    local
      barr: THREAD_BARRIER;
      data: SHARED_DATA;
      mtx: MUTEX;
      cnd_var: CONDITION_VARIABLE;
      start_cnd_var: CONDITION_VARIABLE;
      p: PRODUCER;
      c: CONSUMER;
      i: INTEGER;
      msg: STRING;
    do
      !!msg.make(80);
      !!data.make;
      !!mtx.make;
      !!cnd_var.make;
      !!start_cnd_var.make;
      !!barr.make;
      barr.sign_on;
      from
        i := 1
      until
        i > num_consumers
      loop
        msg.copy("Creating consumer ");
        msg.append(i.to_string);
        msg.append("...");
        print_line(msg);
        !!c.make(i,data,mtx,cnd_var,start_cnd_var,barr);
        c.start;
        i := i + 1;
      end;
      from
        i := 1
      until
        i > num_producer_stages
      loop
        msg.copy("Creating producer ");
        msg.append(i.to_string);
        msg.append(" ...");
        print_line(msg);
        !!p.make(i,num_items,data,mtx,cnd_var,start_cnd_var,barr);
        msg.copy("%N***%N");
        msg.append("*** START NEW PHASE ***%N");
        msg.append("***%N");
        print_line(msg);
        p.start;

        mtx.lock;
          -- sync: producer stated
        from until data.number_of_producers = 1
        loop
          mtx.unlock;
          us_sleep(1000*random_integer(100));
          mtx.lock;
        end;
          -- sync: consumers ready
        from until data.number_of_consumers = num_consumers
        loop
          mtx.unlock;
          start_cnd_var.signal;
          us_sleep(1000*random_integer(100));
          mtx.lock;
        end;
        mtx.unlock;

        if i = num_producer_stages then
          mtx.lock;
          data.destroy;
          mtx.unlock
        end;
        debug
          print_line("Main thread waiting on barrier...");
        end;
        barr.wait;
        debug
          print_line("Main thread passed barrier.");
        end;
        i := i + 1;
      end;

      join_all -- wait until all producers & consumers terminate
    end;

end -- MAIN

