--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2000
--

class PRODUCER

inherit
  THREAD

creation
  make

feature {PRODUCER}

  main is
    local
      j,r: INTEGER;
      str: STRING;
      i: ITEM;
      msg: STRING;
    do
      !!msg.make(80);
      msg.copy("Producer ");
      msg.append(id.to_string);
      msg.append(" started.");
      print_line(msg);
      barr.sign_on;
      from
        j := 1
      until
        j > num_items
      loop
        from
          r := random_integer(5);
        until
          r = 0 or j > num_items
        loop
          !!str.make(16);
          str.copy("produced by ");
          str.append(id.to_string);
          !!i;
          i.set(j,str);
          data_mutex.lock; -- serialize shared data access
          if j = 1 then
            data.activate_producer -- producer activated after
                                   --  producing one item
          end;
          data.add(i);
          cond_var.signal; -- notify new entry to [any] waiting consumer
          data_mutex.unlock;
          j := j + 1;
          r := r - 1
        end;
        us_sleep(1000*random_integer(1000));
      end;
      data_mutex.lock;
      data.deactivate_producer;
        -- sync: consumers
      from until not data.consuming_active
      loop
        data_mutex.unlock;
        cond_var.signal;
        us_sleep(1000*random_integer(100));
        data_mutex.lock;
      end;
      data_mutex.unlock;
      debug
        msg.copy("Producer ");
        msg.append(id.to_string);
        msg.append(" waiting on barrier...");
        print_line(msg);
      end;
      barr.wait;
      barr.sign_off;
      msg.copy("Producer ");
      msg.append(id.to_string);
      msg.append(" finish.");
      print_line(msg);
    end;

feature

  make(tid: INTEGER;nitems: INTEGER;dt: SHARED_DATA;mtx: MUTEX;cvar,start_cvar: CONDITION_VARIABLE;brr: THREAD_BARRIER) is
    do
      id := tid;
      num_items := nitems;
      data := dt;
      data_mutex := mtx;
      cond_var := cvar;
      barr := brr
    end;

  id: INTEGER;

  num_items: INTEGER;

  data: SHARED_DATA;

  data_mutex: MUTEX;

  cond_var: CONDITION_VARIABLE;

  barr: THREAD_BARRIER;

end -- PRODUCER

