--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), October 2000
--

class CONSUMER

inherit
  THREAD

creation
  make

feature {CONSUMER}

  main is
    local
      i: ITEM;
      msg: STRING;
    do
      !!msg.make(80);
      msg.copy("Consumer ");
      msg.append(id.to_string);
      msg.append(" started.");
      print_line(msg);
      data_mutex.lock;
      from
      until
        data.finish
      loop
        data_mutex.unlock;
        debug
          msg.copy("Consumer ");
          msg.append(id.to_string);
          msg.append(" waiting on initialization barrier...");
          print_line(msg);
        end;
        barr_init.wait;
        debug
          msg.copy("Consumer ");
          msg.append(id.to_string);
          msg.append(" passed initialization barrier...");
          print_line(msg);
        end;
        data_mutex.lock;
        from
        until
          data.empty and not data.production_active
        loop
          cond_var.wait(data_mutex);
          if not data.empty then
            i := data.item;
            data.remove;
            msg.copy(i.str);
            msg.append(" and consumed by ");
            msg.append(id.to_string);
            print_line(msg);
            if not data.empty then
              cond_var.signal;
              data_mutex.unlock;
              us_sleep(1000*random_integer(100));
              data_mutex.lock;
            elseif not data.production_active then
              cond_var.broadcast;
            end;
          end;
        end;
        debug
          msg.copy("Consumer ");
          msg.append(id.to_string);
          msg.append(" waiting on finalization barrier...");
          print_line(msg);
        end;
        data_mutex.unlock;
        barr_finish.wait;
        debug
          msg.copy("Consumer ");
          msg.append(id.to_string);
          msg.append(" passed finalization barrier...");
          print_line(msg);
        end;
        data_mutex.lock;
      end;
      data_mutex.unlock;
      msg.copy("Consumer ");
      msg.append(id.to_string);
      msg.append(" finish.");
      print_line(msg);
    end;

feature

  make(tid: INTEGER;dt: SHARED_DATA;mtx: MUTEX;cvar: CONDITION_VARIABLE;brr_init,brr_finish: THREAD_BARRIER) is
    do
      id := tid;
      data := dt;
      data_mutex := mtx;
      cond_var := cvar;
      barr_init := brr_init;
      barr_finish := brr_finish
    end;

  id: INTEGER;

  data: SHARED_DATA;

  data_mutex: MUTEX;

  cond_var: CONDITION_VARIABLE;

  barr_init,barr_finish: THREAD_BARRIER;

end -- CONSUMER

