-- This  file  is   free  software,  which   comes  along  with   thread-safe
-- SmallEiffel. This software  is distributed  in the  hope that  it will  be
-- useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
-- you want, provided this  header is kept unaltered,  and a notification  of
-- the changes is  added. You  are allowed to  redistribute it  and sell  it,
-- alone or as a part of another product.
--
-- (C) Miguel Oliveira e Silva, May 2003
--

class X11_COLOR

inherit
  X11_GLOBAL

creation
  make_white_color,make_black_color,make,make_from_external

feature

  make_white_color(disp: X11_DISPLAY) is
    require
      disp /= Void
    do
      color_var := c_x_make_white_pixel(disp.disp_var)
    end;

  make_black_color(disp: X11_DISPLAY) is
    require
      disp /= Void
    do
      color_var := c_x_make_black_pixel(disp.disp_var)
    end;

  make(disp: X11_DISPLAY;name: STRING) is
    require
      disp /= Void;
      name /= Void
      -- valid_color(name)
    do
      color_var := c_x_make_color_pixel(disp.disp_var,name.to_external)
    ensure
      not color_var.is_null
    end;

feature {X11_GRAPHIC_CONTEXT}

  make_from_external(var: POINTER) is
    do
      color_var := var;
    end;

feature {X11_WINDOW,X11_GRAPHIC_CONTEXT}

  color_var: POINTER;

feature {NONE}

  c_x_make_white_pixel(x11_disp: POINTER): POINTER is
    external "C"
    alias "x_make_white_pixel"
    end;

  c_x_make_black_pixel(x11_disp: POINTER): POINTER is
    external "C"
    alias "x_make_black_pixel"
    end;

  c_x_make_color_pixel(x11_disp: POINTER;color_name: POINTER): POINTER is
    external "C"
    alias "x_make_color_pixel"
    end;

end -- X11_COLOR

