-- This  file  is   free  software,  which   comes  along  with   thread-safe
-- SmallEiffel. This software  is distributed  in the  hope that  it will  be
-- useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
-- you want, provided this  header is kept unaltered,  and a notification  of
-- the changes is  added. You  are allowed to  redistribute it  and sell  it,
-- alone or as a part of another product.
--
-- (C) Miguel Oliveira e Silva, September 2003
--

class X11_CURSOR

inherit
  X11_GLOBAL

creation
  make

feature

  make(disp: X11_DISPLAY) is
    require
      disp /= Void
    do
      curs_var := c_x_make_cursor(disp.disp_var);
      created := false
    ensure
      not curs_var.is_null
    end;

  create_from_shape(shape: INTEGER) is
    require
      not created
    do
      c_x_create_font_cursor(curs_var,shape);
      created := true
    end;

  free is
    require
      created
    do
      c_x_free_cursor(curs_var);
      created := false
    end;

  created: BOOLEAN;

feature {X11_WINDOW}

  curs_var: POINTER;

feature {NONE}

  c_x_make_cursor(x11_disp: POINTER): POINTER is
    external "C"
    alias "x_make_cursor"
    end;

  c_x_create_font_cursor(x11_cur: POINTER;shape: INTEGER) is
    external "C"
    alias "x_create_font_cursor"
    end;

  c_x_free_cursor(x11_cur: POINTER) is
    external "C"
    alias "x_free_cursor"
    end;

end -- X11_CURSOR

