-- This  file  is   free  software,  which   comes  along  with   thread-safe
-- SmallEiffel. This software  is distributed  in the  hope that  it will  be
-- useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
-- you want, provided this  header is kept unaltered,  and a notification  of
-- the changes is  added. You  are allowed to  redistribute it  and sell  it,
-- alone or as a part of another product.
--
-- (C) Miguel Oliveira e Silva, May 2003
--

class X11_GLOBAL

feature -- events codes (IMPORTANT: same codes as in X.h)
        -- redefined here as constants to allow the use of 'inspect'

  event_key_press:         INTEGER is  2;
  event_key_release:       INTEGER is  3;
  event_button_press:      INTEGER is  4;
  event_button_release:    INTEGER is  5;
  event_motion_notify:     INTEGER is  6;
  event_enter_notify:      INTEGER is  7;
  event_leave_notify:      INTEGER is  8;
  event_focus_in:          INTEGER is  9;
  event_focus_out:         INTEGER is 10;
  event_keymap_notify:     INTEGER is 11;
  event_expose:            INTEGER is 12;
  event_graphics_expose:   INTEGER is 13;
  event_no_expose:         INTEGER is 14;
  event_visibility_notify: INTEGER is 15;
  event_create_notify:     INTEGER is 16;
  event_destroy_notify:    INTEGER is 17;
  event_unmap_notify:      INTEGER is 18;
  event_map_notify:        INTEGER is 19;
  event_map_request:       INTEGER is 20;
  event_reparent_notify:   INTEGER is 21;
  event_configure_notify:  INTEGER is 22;
  event_configure_request: INTEGER is 23;
  event_gravity_notify:    INTEGER is 24;
  event_resize_request:    INTEGER is 25;
  event_circulate_notify:  INTEGER is 26;
  event_circulate_request: INTEGER is 27;
  event_property_notify:   INTEGER is 28;
  event_selection_clear:   INTEGER is 29;
  event_selection_request: INTEGER is 30;
  event_selection_notify:  INTEGER is 31;
  event_colormap_notify:   INTEGER is 32;
  event_client_message:    INTEGER is 33;
  event_mapping_notify:    INTEGER is 34;

feature -- events masks (IMPORTANT: same codes as in X.h)

  no_event_mask:              BIT 32 is 0000000000000000000000000B;
  key_press_mask:             BIT 32 is 0000000000000000000000001B;
  key_release_mask:           BIT 32 is 0000000000000000000000010B;
  button_press_mask:          BIT 32 is 0000000000000000000000100B;
  button_release_mask:        BIT 32 is 0000000000000000000001000B;
  enter_window_mask:          BIT 32 is 0000000000000000000010000B;
  leave_window_mask:          BIT 32 is 0000000000000000000100000B;
  pointer_motion_mask:        BIT 32 is 0000000000000000001000000B;
  pointer_motion_hint_mask:   BIT 32 is 0000000000000000010000000B;
  button1_motion_mask:        BIT 32 is 0000000000000000100000000B;
  button2_motion_mask:        BIT 32 is 0000000000000001000000000B;
  button3_motion_mask:        BIT 32 is 0000000000000010000000000B;
  button4_motion_mask:        BIT 32 is 0000000000000100000000000B;
  button5_motion_mask:        BIT 32 is 0000000000001000000000000B;
  button_motion_mask:         BIT 32 is 0000000000010000000000000B;
  keymap_state_mask:          BIT 32 is 0000000000100000000000000B;
  exposure_mask:              BIT 32 is 0000000001000000000000000B;
  visibility_change_mask:     BIT 32 is 0000000010000000000000000B;
  structure_notify_mask:      BIT 32 is 0000000100000000000000000B;
  resize_redirect_mask:       BIT 32 is 0000001000000000000000000B;
  substructure_notify_mask:   BIT 32 is 0000010000000000000000000B;
  substructure_redirect_mask: BIT 32 is 0000100000000000000000000B;
  focus_change_mask:          BIT 32 is 0001000000000000000000000B;
  property_change_mask:       BIT 32 is 0010000000000000000000000B;
  colormap_change_mask:       BIT 32 is 0100000000000000000000000B;
  owner_grab_button_mask:     BIT 32 is 1000000000000000000000000B;

feature -- Graphic context functions (same values as in X.h)

  gx_min: INTEGER is
    external "C macro use <X11/X.h>" alias "GXclear" end;

  gx_max: INTEGER is
    external "C macro use <X11/X.h>" alias "GXset" end;

  gx_clear: INTEGER is -- 0
    external "C macro use <X11/X.h>" alias "GXclear" end;

  gx_and: INTEGER is -- src AND dst
    external "C macro use <X11/X.h>" alias "GXand" end;

  gx_and_reverse: INTEGER is -- src AND NOT dst
    external "C macro use <X11/X.h>" alias "GXandReverse" end;

  gx_copy: INTEGER is -- src (default)
    external "C macro use <X11/X.h>" alias "GXcopy" end;

  gx_and_inverted: INTEGER is -- NOT src AND dst
    external "C macro use <X11/X.h>" alias "GXandInverted" end;

  gx_noop: INTEGER is -- dst
    external "C macro use <X11/X.h>" alias "GXnoop" end;

  gx_xor: INTEGER is -- src XOR dst
    external "C macro use <X11/X.h>" alias "GXxor" end;

  gx_or: INTEGER is -- src OR dst
    external "C macro use <X11/X.h>" alias "GXor" end;

  gx_nor: INTEGER is -- NOT src AND NOT dst
    external "C macro use <X11/X.h>" alias "GXnor" end;

  gx_equiv: INTEGER is -- NOT src XOR dst
    external "C macro use <X11/X.h>" alias "GXequiv" end;

  gx_invert: INTEGER is -- NOT dst
    external "C macro use <X11/X.h>" alias "GXinvert" end;

  gx_xor_reverse: INTEGER is -- src OR NOT dst
    external "C macro use <X11/X.h>" alias "GXorReverse" end;

  gx_copy_inverted: INTEGER is -- NOT src
    external "C macro use <X11/X.h>" alias "GXcopyInverted" end;

  gx_or_inverted: INTEGER is -- NOT src OR dst
    external "C macro use <X11/X.h>" alias "GXorInverted" end;

  gx_nand: INTEGER is -- NOT src OR NOT dst
    external "C macro use <X11/X.h>" alias "GXnand" end;

  gx_set: INTEGER is -- 1
    external "C macro use <X11/X.h>" alias "GXset" end;

feature -- line style

  line_solid: INTEGER is -- default
    external "C macro use <X11/X.h>" alias "LineSolid" end;

  line_on_off_dash: INTEGER is
    external "C macro use <X11/X.h>" alias "LineOnOffDash" end;

  line_double_dash: INTEGER is
    external "C macro use <X11/X.h>" alias "LineDoubleDash" end;

feature -- cap style

  cap_not_last: INTEGER is
    external "C macro use <X11/X.h>" alias "CapNotLast" end;

  cap_butt: INTEGER is
    external "C macro use <X11/X.h>" alias "CapButt" end;

  cap_round: INTEGER is
    external "C macro use <X11/X.h>" alias "CapRound" end;

  cap_projecting: INTEGER is
    external "C macro use <X11/X.h>" alias "CapProjecting" end;

feature -- join style

  join_miter: INTEGER is
    external "C macro use <X11/X.h>" alias "JoinMiter" end;

  join_round: INTEGER is
    external "C macro use <X11/X.h>" alias "JoinRound" end;

  join_bevel: INTEGER is
    external "C macro use <X11/X.h>" alias "JoinBevel" end;

feature -- arc mode

  arc_chord: INTEGER is
    external "C macro use <X11/X.h>" alias "ArcChord" end;

  arc_pie_slice: INTEGER is -- default
    external "C macro use <X11/X.h>" alias "ArcPieSlice" end;

feature -- fill style

  fill_solid: INTEGER is
    external "C macro use <X11/X.h>" alias "FillSolid" end;

  fill_tiled: INTEGER is
    external "C macro use <X11/X.h>" alias "FillTiled" end;

  fill_stippled: INTEGER is
    external "C macro use <X11/X.h>" alias "FillStippled" end;

  fill_opaque_stippled: INTEGER is
    external "C macro use <X11/X.h>" alias "FillOpaqueStippled" end;

feature -- fill rule

  even_odd_rule: INTEGER is
    external "C macro use <X11/X.h>" alias "EvenOddRule" end;

  winding_rule: INTEGER is
    external "C macro use <X11/X.h>" alias "WindingRule" end;

feature -- CoordinateMode for drawing routines

  coord_mode_origin: INTEGER is -- relative to the origin
    external "C macro use <X11/X.h>" alias "CoordModeOrigin" end;

  coord_mode_previous: INTEGER is -- relative to previous point
    external "C macro use <X11/X.h>" alias "CoordModePrevious" end;

feature -- Polygon shapes

  complex: INTEGER is -- paths may intersect
    external "C macro use <X11/X.h>" alias "Complex" end;

  nonconvex: INTEGER is -- no paths intersect, but not convex
    external "C macro use <X11/X.h>" alias "Nonconvex" end;

  convex: INTEGER is -- wholly convex
    external "C macro use <X11/X.h>" alias "Convex" end;

feature -- shared colors (ATTENTION: it only works for a unique X11 Display)

  x11_black_color(x11: X11_DISPLAY): X11_COLOR is
    once {"class","process"}
      !!Result.make(x11,"black")
    end

  x11_white_color(x11: X11_DISPLAY): X11_COLOR is
    once {"class","process"}
      !!Result.make(x11,"white")
    end

  x11_green_color(x11: X11_DISPLAY): X11_COLOR is
    once {"class","process"}
      !!Result.make(x11,"green")
    end

  x11_red_color(x11: X11_DISPLAY): X11_COLOR is
    once {"class","process"}
      !!Result.make(x11,"red")
    end

  x11_blue_color(x11: X11_DISPLAY): X11_COLOR is
    once {"class","process"}
      !!Result.make(x11,"blue")
    end

  x11_yellow_color(x11: X11_DISPLAY): X11_COLOR is
    once {"class","process"}
      !!Result.make(x11,"yellow")
    end

feature -- some of the default fonts names

  font_left_to_right: INTEGER is
    external "C macro use <X11/X.h>" alias "FontLeftToRight" end;

  font_right_to_left: INTEGER is
    external "C macro use <X11/X.h>" alias "FontRightToLeft" end;

feature -- some of the default fonts names

  font_6x10: STRING is "6x10";
  font_6x12: STRING is "6x12";
  font_6x13: STRING is "6x13";
  font_8x13: STRING is "8x13";
  font_8x13bold: STRING is "8x13bold";
  font_9x15: STRING is "9x15";
  font_fixed: STRING is "fixed";
  font_variable: STRING is "variable";

feature -- KeySym's fetched from keysym.h definition

    -- Miscellany

  key_sym_void_symbol: INTEGER is -- void symbol
    external "C macro use <X11/keysym.h>" alias "XK_VoidSymbol" end;

  key_sym_back_space: INTEGER is -- back space, back char
    external "C macro use <X11/keysym.h>" alias "XK_BackSpace" end;

  key_sym_tab: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Tab" end;

  key_sym_linefeed: INTEGER is -- Linefeed, LF
    external "C macro use <X11/keysym.h>" alias "XK_Linefeed" end;

  key_sym_clear: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Clear" end;

  key_sym_return: INTEGER is -- Return, enter
    external "C macro use <X11/keysym.h>" alias "XK_Return" end;

  key_sym_pause: INTEGER is -- Pause, hold
    external "C macro use <X11/keysym.h>" alias "XK_Pause" end;

  key_sym_scroll_lock: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Scroll_Lock" end;

  key_sym_sys_req: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Sys_Req" end;

  key_sym_escape: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Escape" end;

  key_sym_delete: INTEGER is -- Delete, rubout
    external "C macro use <X11/keysym.h>" alias "XK_Delete" end;

    -- Cursor control & motion

  key_sym_home: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Home" end;

  key_sym_left: INTEGER is -- Move left, left arrow
    external "C macro use <X11/keysym.h>" alias "XK_Left" end;

  key_sym_up: INTEGER is -- Move up, up arrow
    external "C macro use <X11/keysym.h>" alias "XK_Up" end;

  key_sym_right: INTEGER is -- Move right, right arrow
    external "C macro use <X11/keysym.h>" alias "XK_Right" end;

  key_sym_down: INTEGER is -- Move down, down arrow
    external "C macro use <X11/keysym.h>" alias "XK_Down" end;

  key_sym_prior: INTEGER is -- Prior, previous
    external "C macro use <X11/keysym.h>" alias "XK_Prior" end;

  key_sym_page_up: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Page_Up" end;

  key_sym_next: INTEGER is -- Next
    external "C macro use <X11/keysym.h>" alias "XK_Next" end;

  key_sym_page_down: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Page_Down" end;

  key_sym_end: INTEGER is -- EOL
    external "C macro use <X11/keysym.h>" alias "XK_End" end;

  key_sym_begin: INTEGER is -- BOL
    external "C macro use <X11/keysym.h>" alias "XK_Begin" end;

    -- Misc Functions

  key_sym_select: INTEGER is -- Select, mark
    external "C macro use <X11/keysym.h>" alias "XK_Select" end;

  key_sym_print: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Print" end;

  key_sym_execute: INTEGER is -- Execute, run, do
    external "C macro use <X11/keysym.h>" alias "XK_Execute" end;

  key_sym_insert: INTEGER is -- Insert, insert here
    external "C macro use <X11/keysym.h>" alias "XK_Insert" end;

  key_sym_undo: INTEGER is -- Undo, oops
    external "C macro use <X11/keysym.h>" alias "XK_Undo" end;

  key_sym_redo: INTEGER is -- redo, again
    external "C macro use <X11/keysym.h>" alias "XK_Redo" end;

  key_sym_menu: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Menu" end;

  key_sym_find: INTEGER is -- Find, search
    external "C macro use <X11/keysym.h>" alias "XK_Find" end;

  key_sym_cancel: INTEGER is -- Cancel, stop, abort, exit
    external "C macro use <X11/keysym.h>" alias "XK_Cancel" end;

  key_sym_help: INTEGER is -- Help
    external "C macro use <X11/keysym.h>" alias "XK_Help" end;

  key_sym_break: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Break" end;

  key_sym_mode_switch: INTEGER is -- Character set switch
    external "C macro use <X11/keysym.h>" alias "XK_Mode_switch" end;

  key_sym_script_switch: INTEGER is -- Alias for mode_switch
    external "C macro use <X11/keysym.h>" alias "XK_script_switch" end;

  key_sym_num_lock: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Num_Lock" end;

    -- Keypad Functions, keypad numbers cleverly chosen to map to ascii

  key_sym_keypad_space: INTEGER is -- space
    external "C macro use <X11/keysym.h>" alias "XK_KP_Space" end;

  key_sym_keypad_tab: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Tab" end;

  key_sym_keypad_enter: INTEGER is -- enter
    external "C macro use <X11/keysym.h>" alias "XK_KP_Enter" end;

  key_sym_keypad_home: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Home" end;

  key_sym_keypad_left: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Left" end;

  key_sym_keypad_up: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Up" end;

  key_sym_keypad_right: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Right" end;

  key_sym_keypad_down: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Down" end;

  key_sym_keypad_prior: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Prior" end;

  key_sym_keypad_page_up: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Page_Up" end;

  key_sym_keypad_next: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Next" end;

  key_sym_keypad_page_down: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Page_Down" end;

  key_sym_keypad_end: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_End" end;

  key_sym_keypad_begin: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Begin" end;

  key_sym_keypad_insert: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Insert" end;

  key_sym_keypad_delete: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Delete" end;

  key_sym_keypad_equal: INTEGER is -- equals
    external "C macro use <X11/keysym.h>" alias "XK_KP_Equal" end;

  key_sym_keypad_multiply: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Multiply" end;

  key_sym_keypad_add: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Add" end;

  key_sym_keypad_separator: INTEGER is -- separator, often comma
    external "C macro use <X11/keysym.h>" alias "XK_KP_Separator" end;

  key_sym_keypad_subtract: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Subtract" end;

  key_sym_keypad_decimal: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Decimal" end;

  key_sym_keypad_divide: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_Divide" end;

  key_sym_keypad_0: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_0" end;

  key_sym_keypad_1: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_1" end;

  key_sym_keypad_2: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_2" end;

  key_sym_keypad_3: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_3" end;

  key_sym_keypad_4: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_4" end;

  key_sym_keypad_5: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_5" end;

  key_sym_keypad_6: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_6" end;

  key_sym_keypad_7: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_7" end;

  key_sym_keypad_8: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_8" end;

  key_sym_keypad_9: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_KP_9" end;

    -- Auxilliary Functions

  key_sym_f1: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F1" end;

  key_sym_f2: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F2" end;

  key_sym_f3: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F3" end;

  key_sym_f4: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F4" end;

  key_sym_f5: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F5" end;

  key_sym_f6: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F6" end;

  key_sym_f7: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F7" end;

  key_sym_f8: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F8" end;

  key_sym_f9: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F9" end;

  key_sym_f10: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F10" end;

  key_sym_f11: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F11" end;

  key_sym_f12: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F12" end;

    -- Modifiers

  key_sym_shift_l: INTEGER is -- Left shift
    external "C macro use <X11/keysym.h>" alias "XK_Shift_L" end;

  key_sym_shift_r: INTEGER is -- Right shift
    external "C macro use <X11/keysym.h>" alias "XK_Shift_R" end;

  key_sym_control_l: INTEGER is -- Left control
    external "C macro use <X11/keysym.h>" alias "XK_Control_L" end;

  key_sym_control_r: INTEGER is -- Right control
    external "C macro use <X11/keysym.h>" alias "XK_Control_R" end;

  key_sym_caps_lock: INTEGER is -- Caps lock
    external "C macro use <X11/keysym.h>" alias "XK_Caps_Lock" end;

  key_sym_shift_lock: INTEGER is -- Shift lock
    external "C macro use <X11/keysym.h>" alias "XK_Shift_Lock" end;

  key_sym_meta_l: INTEGER is -- Left meta
    external "C macro use <X11/keysym.h>" alias "XK_Meta_L" end;

  key_sym_meta_r: INTEGER is -- Right meta
    external "C macro use <X11/keysym.h>" alias "XK_Meta_R" end;

  key_sym_alt_l: INTEGER is -- Left alt
    external "C macro use <X11/keysym.h>" alias "XK_Alt_L" end;

  key_sym_alt_r: INTEGER is -- Right alt
    external "C macro use <X11/keysym.h>" alias "XK_Alt_R" end;

  key_sym_super_l: INTEGER is -- Left super
    external "C macro use <X11/keysym.h>" alias "XK_Super_L" end;

  key_sym_super_r: INTEGER is -- Right super
    external "C macro use <X11/keysym.h>" alias "XK_Super_R" end;

  key_sym_hyper_l: INTEGER is -- Left hyper
    external "C macro use <X11/keysym.h>" alias "XK_Hyper_L" end;

  key_sym_hyper_r: INTEGER is -- Right hyper
    external "C macro use <X11/keysym.h>" alias "XK_Hyper_R" end;

    -- Latin 1

  key_sym_space: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_space" end;

  key_sym_exclam: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_exclam" end;

  key_sym_quotedbl: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_quotedbl" end;

  key_sym_numbersign: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_numbersign" end;

  key_sym_dollar: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_dollar" end;

  key_sym_percent: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_percent" end;

  key_sym_ampersand: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ampersand" end;

  key_sym_apostrophe: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_apostrophe" end;

  key_sym_quoteright: INTEGER is -- deprecated
    external "C macro use <X11/keysym.h>" alias "XK_quoteright" end;

  key_sym_parenleft: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_parenleft" end;

  key_sym_parenright: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_parenright" end;

  key_sym_asterisk: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_asterisk" end;

  key_sym_plus: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_plus" end;

  key_sym_comma: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_comma" end;

  key_sym_minus: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_minus" end;

  key_sym_period: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_period" end;

  key_sym_slash: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_slash" end;

  key_sym_0: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_0" end;

  key_sym_1: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_1" end;

  key_sym_2: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_2" end;

  key_sym_3: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_3" end;

  key_sym_4: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_4" end;

  key_sym_5: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_5" end;

  key_sym_6: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_6" end;

  key_sym_7: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_7" end;

  key_sym_8: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_8" end;

  key_sym_9: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_9" end;

  key_sym_colon: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_colon" end;

  key_sym_semicolon: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_semicolon" end;

  key_sym_less: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_less" end;

  key_sym_equal: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_equal" end;

  key_sym_greater: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_greater" end;

  key_sym_question: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_question" end;

  key_sym_at: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_at" end;

  key_sym_uppercase_a: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_A" end;

  key_sym_uppercase_b: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_B" end;

  key_sym_uppercase_c: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_C" end;

  key_sym_uppercase_d: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_D" end;

  key_sym_uppercase_e: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_E" end;

  key_sym_uppercase_f: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_F" end;

  key_sym_uppercase_g: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_G" end;

  key_sym_uppercase_h: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_H" end;

  key_sym_uppercase_i: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_I" end;

  key_sym_uppercase_j: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_J" end;

  key_sym_uppercase_k: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_K" end;

  key_sym_uppercase_l: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_L" end;

  key_sym_uppercase_m: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_M" end;

  key_sym_uppercase_n: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_N" end;

  key_sym_uppercase_o: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_O" end;

  key_sym_uppercase_p: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_P" end;

  key_sym_uppercase_q: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Q" end;

  key_sym_uppercase_r: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_R" end;

  key_sym_uppercase_s: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_S" end;

  key_sym_uppercase_t: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_T" end;

  key_sym_uppercase_u: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_U" end;

  key_sym_uppercase_v: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_V" end;

  key_sym_uppercase_w: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_W" end;

  key_sym_uppercase_x: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_X" end;

  key_sym_uppercase_y: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Y" end;

  key_sym_uppercase_z: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Z" end;

  key_sym_bracketleft: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_bracketleft" end;

  key_sym_backslash: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_backslash" end;

  key_sym_bracketright: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_bracketright" end;

  key_sym_asciicircum: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_asciicircum" end;

  key_sym_underscore: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_underscore" end;

  key_sym_grave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_grave" end;

  key_sym_quoteleft: INTEGER is -- deprecated
    external "C macro use <X11/keysym.h>" alias "XK_quoteleft" end;

  key_sym_a: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_a" end;

  key_sym_b: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_b" end;

  key_sym_c: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_c" end;

  key_sym_d: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_d" end;

  key_sym_e: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_e" end;

  key_sym_f: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_f" end;

  key_sym_g: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_g" end;

  key_sym_h: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_h" end;

  key_sym_i: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_i" end;

  key_sym_j: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_j" end;

  key_sym_k: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_k" end;

  key_sym_l: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_l" end;

  key_sym_m: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_m" end;

  key_sym_n: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_n" end;

  key_sym_o: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_o" end;

  key_sym_p: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_p" end;

  key_sym_q: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_q" end;

  key_sym_r: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_r" end;

  key_sym_s: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_s" end;

  key_sym_t: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_t" end;

  key_sym_u: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_u" end;

  key_sym_v: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_v" end;

  key_sym_w: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_w" end;

  key_sym_x: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_x" end;

  key_sym_y: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_y" end;

  key_sym_z: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_z" end;

  key_sym_braceleft: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_braceleft" end;

  key_sym_bar: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_bar" end;

  key_sym_braceright: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_braceright" end;

  key_sym_asciitilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_asciitilde" end;

  key_sym_nobreakspace: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_nobreakspace" end;

  key_sym_exclamdown: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_exclamdown" end;

  key_sym_cent: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_cent" end;

  key_sym_sterling: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_sterling" end;

  key_sym_currency: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_currency" end;

  key_sym_yen: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_yen" end;

  key_sym_brokenbar: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_brokenbar" end;

  key_sym_section: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_section" end;

  key_sym_diaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_diaeresis" end;

  key_sym_copyright: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_copyright" end;

  key_sym_ordfeminine: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ordfeminine" end;

  key_sym_guillemotleft: INTEGER is -- left angle quotation mark
    external "C macro use <X11/keysym.h>" alias "XK_guillemotleft" end;

  key_sym_notsign: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_notsign" end;

  key_sym_hyphen: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_hyphen" end;

  key_sym_registered: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_registered" end;

  key_sym_macron: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_macron" end;

  key_sym_degree: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_degree" end;

  key_sym_plusminus: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_plusminus" end;

  key_sym_twosuperior: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_twosuperior" end;

  key_sym_threesuperior: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_threesuperior" end;

  key_sym_acute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_acute" end;

  key_sym_mu: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_mu" end;

  key_sym_paragraph: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_paragraph" end;

  key_sym_periodcentered: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_periodcentered" end;

  key_sym_cedilla: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_cedilla" end;

  key_sym_onesuperior: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_onesuperior" end;

  key_sym_masculine: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_masculine" end;

  key_sym_guillemotright: INTEGER is -- right angle quotation mark
    external "C macro use <X11/keysym.h>" alias "XK_guillemotright" end;

  key_sym_onequarter: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_onequarter" end;

  key_sym_onehalf: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_onehalf" end;

  key_sym_threequarters: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_threequarters" end;

  key_sym_questiondown: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_questiondown" end;

  key_sym_uppercase_agrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Agrave" end;

  key_sym_uppercase_aacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Aacute" end;

  key_sym_uppercase_acircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Acircumflex" end;

  key_sym_uppercase_atilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Atilde" end;

  key_sym_uppercase_adiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Adiaeresis" end;

  key_sym_uppercase_aring: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Aring" end;

  key_sym_uppercase_ae: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_AE" end;

  key_sym_uppercase_ccedilla: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ccedilla" end;

  key_sym_uppercase_egrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Egrave" end;

  key_sym_uppercase_eacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Eacute" end;

  key_sym_uppercase_ecircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ecircumflex" end;

  key_sym_uppercase_ediaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ediaeresis" end;

  key_sym_uppercase_igrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Igrave" end;

  key_sym_uppercase_iacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Iacute" end;

  key_sym_uppercase_icircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Icircumflex" end;

  key_sym_uppercase_idiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Idiaeresis" end;

  key_sym_uppercase_eth: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ETH" end;

  key_sym_uppercase_ntilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ntilde" end;

  key_sym_uppercase_ograve: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ograve" end;

  key_sym_uppercase_oacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Oacute" end;

  key_sym_uppercase_ocircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ocircumflex" end;

  key_sym_uppercase_otilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Otilde" end;

  key_sym_uppercase_odiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Odiaeresis" end;

  key_sym_multiply: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_multiply" end;

  key_sym_uppercase_ooblique: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ooblique" end;

  key_sym_uppercase_oslash: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Oslash" end;

  key_sym_uppercase_ugrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ugrave" end;

  key_sym_uppercase_uacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Uacute" end;

  key_sym_uppercase_ucircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Ucircumflex" end;

  key_sym_uppercase_udiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Udiaeresis" end;

  key_sym_uppercase_yacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_Yacute" end;

  key_sym_uppercase_thorn: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_THORN" end;

  key_sym_ssharp: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ssharp" end;

  key_sym_agrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_agrave" end;

  key_sym_aacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_aacute" end;

  key_sym_acircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_acircumflex" end;

  key_sym_atilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_atilde" end;

  key_sym_adiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_adiaeresis" end;

  key_sym_aring: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_aring" end;

  key_sym_ae: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ae" end;

  key_sym_ccedilla: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ccedilla" end;

  key_sym_egrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_egrave" end;

  key_sym_eacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_eacute" end;

  key_sym_ecircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ecircumflex" end;

  key_sym_ediaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ediaeresis" end;

  key_sym_igrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_igrave" end;

  key_sym_iacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_iacute" end;

  key_sym_icircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_icircumflex" end;

  key_sym_idiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_idiaeresis" end;

  key_sym_eth: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_eth" end;

  key_sym_ntilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ntilde" end;

  key_sym_ograve: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ograve" end;

  key_sym_oacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_oacute" end;

  key_sym_ocircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ocircumflex" end;

  key_sym_otilde: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_otilde" end;

  key_sym_odiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_odiaeresis" end;

  key_sym_division: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_division" end;

  key_sym_oslash: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_oslash" end;

  key_sym_ooblique: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ooblique" end;

  key_sym_ugrave: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ugrave" end;

  key_sym_uacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_uacute" end;

  key_sym_ucircumflex: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ucircumflex" end;

  key_sym_udiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_udiaeresis" end;

  key_sym_yacute: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_yacute" end;

  key_sym_thorn: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_thorn" end;

  key_sym_ydiaeresis: INTEGER is
    external "C macro use <X11/keysym.h>" alias "XK_ydiaeresis" end;

feature -- Standard Cursors

  xcursor_x_cursor: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_X_cursor" end;

  xcursor_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_arrow" end;

  xcursor_based_arrow_down: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_based_arrow_down" end;

  xcursor_based_arrow_up: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_based_arrow_up" end;

  xcursor_boat: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_boat" end;

  xcursor_bogosity: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_bogosity" end;

  xcursor_bottom_left_corner: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_bottom_left_corner" end;

  xcursor_bottom_right_corner: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_bottom_right_corner" end;

  xcursor_bottom_side: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_bottom_side" end;

  xcursor_bottom_tee: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_bottom_tee" end;

  xcursor_box_spiral: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_box_spiral" end;

  xcursor_center_ptr: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_center_ptr" end;

  xcursor_circle: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_circle" end;

  xcursor_clock: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_clock" end;

  xcursor_coffee_mug: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_coffee_mug" end;

  xcursor_cross: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_cross" end;

  xcursor_cross_reverse: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_cross_reverse" end;

  xcursor_crosshair: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_crosshair" end;

  xcursor_diamond_cross: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_diamond_cross" end;

  xcursor_dot: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_dot" end;

  xcursor_dotbox: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_dotbox" end;

  xcursor_double_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_double_arrow" end;

  xcursor_draft_large: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_draft_large" end;

  xcursor_draft_small: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_draft_small" end;

  xcursor_draped_box: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_draped_box" end;

  xcursor_exchange: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_exchange" end;

  xcursor_fleur: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_fleur" end;

  xcursor_gobbler: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_gobbler" end;

  xcursor_gumby: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_gumby" end;

  xcursor_hand1: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_hand1" end;

  xcursor_hand2: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_hand2" end;

  xcursor_heart: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_heart" end;

  xcursor_icon: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_icon" end;

  xcursor_iron_cross: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_iron_cross" end;

  xcursor_left_ptr: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_left_ptr" end;

  xcursor_left_side: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_left_side" end;

  xcursor_left_tee: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_left_tee" end;

  xcursor_leftbutton: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_leftbutton" end;

  xcursor_ll_angle: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_ll_angle" end;

  xcursor_lr_angle: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_lr_angle" end;

  xcursor_man: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_man" end;

  xcursor_middlebutton: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_middlebutton" end;

  xcursor_mouse: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_mouse" end;

  xcursor_pencil: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_pencil" end;

  xcursor_pirate: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_pirate" end;

  xcursor_plus: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_plus" end;

  xcursor_question_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_question_arrow" end;

  xcursor_right_ptr: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_right_ptr" end;

  xcursor_right_side: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_right_side" end;

  xcursor_right_tee: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_right_tee" end;

  xcursor_rightbutton: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_rightbutton" end;

  xcursor_rtl_logo: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_rtl_logo" end;

  xcursor_sailboat: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sailboat" end;

  xcursor_sb_down_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sb_down_arrow" end;

  xcursor_sb_h_double_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sb_h_double_arrow" end;

  xcursor_sb_left_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sb_left_arrow" end;

  xcursor_sb_right_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sb_right_arrow" end;

  xcursor_sb_up_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sb_up_arrow" end;

  xcursor_sb_v_double_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sb_v_double_arrow" end;

  xcursor_shuttle: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_shuttle" end;

  xcursor_sizing: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_sizing" end;

  xcursor_spider: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_spider" end;

  xcursor_spraycan: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_spraycan" end;

  xcursor_star: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_star" end;

  xcursor_target: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_target" end;

  xcursor_tcross: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_tcross" end;

  xcursor_top_left_arrow: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_top_left_arrow" end;

  xcursor_top_left_corner: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_top_left_corner" end;

  xcursor_top_right_corner: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_top_right_corner" end;

  xcursor_top_side: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_top_side" end;

  xcursor_top_tee: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_top_tee" end;

  xcursor_trek: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_trek" end;

  xcursor_ul_angle: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_ul_angle" end;

  xcursor_umbrella: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_umbrella" end;

  xcursor_ur_angle: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_ur_angle" end;

  xcursor_watch: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_watch" end;

  xcursor_xterm: INTEGER is
    external "C macro use <X11/cursorfont.h>" alias "XC_xterm" end;

end -- X11_GLOBAL

