/* chr_term.h
** This  file  is   free  software,  which   comes  along  with   thread-safe
** SmallEiffel. This software  is distributed  in the  hope that  it will  be
** useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
** you want, provided this  header is kept unaltered,  and a notification  of
** the changes is  added. You  are allowed to  redistribute it  and sell  it,
** alone or as a part of another product.
**
** (C) Miguel Oliveira e Silva, August 2001
*/

#ifndef CHR_TERM_H
#define CHR_TERM_H

int initialized(void);
void init_display(void);
void end_display(void);
int number_of_lines(void);
int number_of_columns(void);
int is_mouse_usable(void);
void enable_mouse(void);
void disable_mouse(void);
int is_mouse_enabled(void);
int get_mouse_event_mask(void);
void set_mouse_event_mask(int m);
int is_mouse_event_mask_usable(int m);
void enable_keyboard(void);
void disable_keyboard(void);
int is_keyboard_enabled(void);
int last_mouse_x(void);
int last_mouse_y(void);
void set_timeout(int ts);
void unset_timeout(void);
void get_event(void);
int last_cursor_lin(void);
int last_cursor_col(void);
void set_cursor(int lin,int col);
void get_cursor(void);
void do_beep(void);
void clear_screen(void);
void print_char(char c);
void set_normal_text(void);
void set_highlight(void);
void reset_highlight(void);
void set_underline(void);
void reset_underline(void);
void set_reverse(void);
void reset_reverse(void);
void set_blinking(void);
void reset_blinking(void);
void set_dim(void);
void reset_dim(void);
void set_bold(void);
void reset_bold(void);
void set_black_color(void);
void set_red_color(void);
void set_green_color(void);
void set_yellow_color(void);
void set_blue_color(void);
void set_cyan_color(void);
void set_magenta_color(void);
void set_white_color(void);
  /* THREAD_TERMINAL_HANDLER */
void term_hand_lock(void);
void term_hand_unlock(void);

#endif

