--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2001
--

class CLOCK

inherit
  THREAD;
  THREAD_TERMINAL_HANDLER

creation
  make

feature {CLOCK}

  main is
    local
      update_freq,i: INTEGER
    do
      initialize;
      hide_cursor;
      timer.reset_lost_periods;
      start_counter := timer.counter;
      update_freq := 200 // timer.period;
      from
        i := 0
      until
        finish
      loop
        timer.wait;
        if i = update_freq then
          write_time;
          i := 0
        else
          i := i + 1
        end
      end;
      terminate;
    end;

feature

  hours: INTEGER;

  minutes: INTEGER;

  seconds: INTEGER;

  write_time is
    do
      seconds := (timer.counter - start_counter)*timer.period // 1000;
      minutes := seconds // 60;
      seconds := seconds \\ 60;
      hours := minutes // 60;
      minutes := minutes \\ 60;
      write_at(1,1,(hours // 10).to_string);
      write_at(1,2,(hours \\ 10).to_string);
      write_at(1,3,":");
      write_at(1,4,(minutes // 10).to_string);
      write_at(1,5,(minutes \\ 10).to_string);
      write_at(1,6,":");
      write_at(1,7,(seconds // 10).to_string);
      write_at(1,8,(seconds \\ 10).to_string);
    end;

  make(tmr: TIMER) is
    do
      timer := tmr;
      is_finish := false;
      !!mtx.make;
    end;

feature

  finish: BOOLEAN is
    do
      mtx.lock;
      Result := is_finish;
      mtx.unlock
    end;

  terminate_clock is
    do
      mtx.lock;
      is_finish := true;
      mtx.unlock
    end;

feature {NONE}

  is_finish: BOOLEAN;

  start_counter: INTEGER;

  timer: TIMER;

  mtx: MUTEX;

end -- CLOCK

