--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2001
--

class CLOCK

inherit
  THREAD;
  X11_GLOBAL

creation
  make

feature {CLOCK}

  main is
    local
      update_freq,i: INTEGER;
      fnt: X11_FONT
    do
      !!fnt.make(x11_win.display);
      fnt.load("fixed");
      x11_win.graphic_context.set_font(fnt);
      x11_win.graphic_context.set_foreground(x11_blue_color(x11_win.display));
      timer.reset_lost_periods;
      start_counter := timer.counter;
      update_freq := 200 // timer.period;
      from
        i := 0
      until
        finish
      loop
        timer.wait;
        if i = update_freq then
          write_time;
          i := 0
        else
          i := i + 1
        end
      end;
    end;

feature

  hours: INTEGER;

  minutes: INTEGER;

  seconds: INTEGER;

  time_string: STRING is
    once {"object"}
      !!Result.make(32)
    end;

  write_time is
    do
      seconds := (timer.counter - start_counter)*timer.period // 1000;
      minutes := seconds // 60;
      seconds := seconds \\ 60;
      hours := minutes // 60;
      minutes := minutes \\ 60;
      time_string.clear;
      --time_string.append((hours // 10).to_string);
      time_string.append((hours // 10).to_string);
      time_string.append((hours \\ 10).to_string);
      time_string.append(":");
      time_string.append((minutes // 10).to_string);
      time_string.append((minutes \\ 10).to_string);
      time_string.append(":");
      time_string.append((seconds // 10).to_string);
      time_string.append((seconds \\ 10).to_string);
      --x11_win.clear;
      x11_win.draw_image_string(0,10,time_string);
    end;

  make(tmr: TIMER;x11_w: X11_WINDOW) is
    do
      timer := tmr;
      x11_win := x11_w;
      is_finish := false;
      !!mtx.make;
    end;

feature

  finish: BOOLEAN is
    do
      mtx.lock;
      Result := is_finish;
      mtx.unlock
    end;

  terminate is
    do
      mtx.lock;
      is_finish := true;
      mtx.unlock
    end;

feature {NONE}

  is_finish: BOOLEAN;

  start_counter: INTEGER;

  timer: TIMER;

  x11_win: X11_WINDOW;

  mtx: MUTEX;

end -- CLOCK

