--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2001
--

class INFO

inherit
  THREAD;
  X11_GLOBAL

creation
  make

feature {INFO}

  main is
    local
      update_freq,i: INTEGER;
      fnt: X11_FONT
    do
      !!fnt.make(x11_win.display);
      fnt.load("fixed");
      x11_win.graphic_context.set_font(fnt);
      x11_win.graphic_context.set_foreground(x11_red_color(x11_win.display));
      timer.reset_lost_periods;
      start_counter := timer.counter;
      update_freq := 200 // timer.period;
      from
        i := 0
      until
        finish
      loop
        timer.wait;
        if i = update_freq then
          write_info;
          i := 0
        else
          i := i + 1
        end
      end;
    end;

feature

  write_info is
    do
      x11_win.draw_image_string(5,x11_win.height - 5,"(exit: Esc)")
    end;

  make(tmr: TIMER;x11_w: X11_WINDOW) is
    do
      timer := tmr;
      x11_win := x11_w;
      is_finish := false;
      !!mtx.make;
    end;

feature

  finish: BOOLEAN is
    do
      mtx.lock;
      Result := is_finish;
      mtx.unlock
    end;

  terminate is
    do
      mtx.lock;
      is_finish := true;
      mtx.unlock
    end;

feature {NONE}

  is_finish: BOOLEAN;

  start_counter: INTEGER;

  timer: TIMER;

  x11_win: X11_WINDOW;

  mtx: MUTEX;

end -- INFO

