--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2001
--

class VECTOR

feature

  x: DOUBLE;

  y: DOUBLE;

  set_x(nx: DOUBLE) is
    do
      x := nx;
    end;

  set_y(ny: DOUBLE) is
    do
      y := ny;
    end;

  set(other: like Current) is
    do
      set_x(other.x);
      set_y(other.y)
    end;

  set_zero is
    do
      x := 0.0;
      y := 0.0;
    end;

  distance(other: like Current): DOUBLE is
    do
      Result := (((other.x-x) ^ 2) + ((other.y-y) ^ 2)).sqrt
    end;

  add(other: like Current) is
    do
      set_x(x + other.x);
      set_y(y + other.y)
    end;

  mult_with_real(r: DOUBLE) is
    do
      set_x(x * r);
      set_y(y * r)
    end;

  div_with_real(r: DOUBLE) is
    require
      r /= 0.0
    do
      set_x(x / r);
      set_y(y / r)
    end;

end -- VECTOR

