--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), November 2000
--

class MAIN

inherit
  THREAD_CONTROL

creation
  make

feature

  num_pipes: INTEGER is 3;

  num_consumers: INTEGER is 7;

  num_producers: INTEGER is 2;

  num_items: INTEGER is 50;

  make is
    local
      pipeline: THREAD_PIPELINE;
      data: SHARED_DATA;
      mtx: MUTEX;
      cnd_var: CONDITION_VARIABLE;
      p: PRODUCER;
      c: CONSUMER;
      pipe_count,cons_count,prod_count: INTEGER;
      msg: STRING;
    do
      !!msg.make(120);
      !!mtx.make;
      !!cnd_var.make;
      !!pipeline.make;

        -- setting pipeline

      msg.copy("Setting pipeline:%N  pipes = ");
      msg.append(num_pipes.to_string);
      msg.append("%N  num consumers = ");
      msg.append(num_consumers.to_string);
      msg.append("%N  num producers = ");
      msg.append(num_producers.to_string);
      msg.append("%N");
      print_line(msg);
      from
        pipe_count := 1
      until
        pipe_count > num_pipes
      loop
        !!data.make;
        from
          cons_count := 1
        until
          cons_count > num_consumers
        loop
          !!c.make(cons_count,data,mtx,cnd_var);
          pipeline.add_thread(c);
          cons_count := cons_count + 1
        end;
        from
          prod_count := 1
        until
          prod_count > num_producers
        loop
          !!p.make(prod_count,num_items,data,mtx,cnd_var);
          pipeline.add_thread(p);
          prod_count := prod_count + 1;
        end;
        pipeline.new_pipe;
        pipe_count := pipe_count + 1
      end;

        -- running pipeline

      msg.copy("Running pipeline...");
      print_line(msg);
      pipeline.start
    end;

end -- MAIN

