--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), October 2000
--

class SHARED_DATA

creation
  make

feature

  make is
    do
      number_of_producers := 0;
      finish_flag := false;
      !!data.make;
    end;

  finish: BOOLEAN is
    do
      Result := not production_active and finish_flag
    end;

  number_of_producers: INTEGER;

  production_active: BOOLEAN is
    do
      Result := number_of_producers > 0
    end;

  activate_producer is
    do
      number_of_producers := number_of_producers + 1
    end;

  deactivate_producer is
    require
      production_active
    do
      number_of_producers := number_of_producers - 1;
      if number_of_producers = 0 then
        finish_flag := true
      end
    end;

  add(i: ITEM) is
    do
      data.add_first(i)
    end;

  remove is
    require
      not empty
    do
      data.remove_last
    end;

  empty: BOOLEAN is
    do
      Result := data.is_empty
    end;

  item: ITEM is
    require
      not empty
    do
      Result := data.last
    end;

feature {SHARED_DATA}

  finish_flag: BOOLEAN;

  data: LINKED_LIST[ITEM];

end -- SHARED_DATA

