--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August-October 2000
--

class CONSUMER

inherit
  THREAD

creation
  make

feature {CONSUMER}

  main is
    local
      i: ITEM;
      msg: STRING;
    do
      !!msg.make(80);
      msg.copy("Consumer ");
      msg.append(id.to_string);
      msg.append(" started.");
      print_line(msg);
      data_mutex.lock;
      from
      until
        data.empty and data.finish
      loop
        cond_var.wait(data_mutex);
        if not data.empty then
          i := data.item;
          data.remove;
          msg.copy(i.str);
          msg.append(" and consumed by ");
          msg.append(id.to_string);
          print_line(msg);
          if not data.empty then
            cond_var.signal
          end;
          data_mutex.unlock;
          us_sleep(1000*random_integer(100));
          data_mutex.lock;
        end
      end;
      data_mutex.unlock;
      msg.copy("Consumer ");
      msg.append(id.to_string);
      msg.append(" finish.");
      print_line(msg);
    end;

feature

  make(tid: INTEGER;dt: SHARED_DATA;mtx: MUTEX;cvar: CONDITION_VARIABLE) is
    do
      id := tid;
      data := dt;
      data_mutex := mtx;
      cond_var := cvar
    end;

  id: INTEGER;

  data: SHARED_DATA;

  data_mutex: MUTEX;

  cond_var: CONDITION_VARIABLE;

end -- CONSUMER

