--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August-October 2000
--

class MAIN

inherit
  THREAD_CONTROL

creation
  make

feature

  num_producers: INTEGER is 5;

  num_consumers: INTEGER is 7;

  num_items: INTEGER is 100;

  make is
    local
      data: SHARED_DATA;
      mtx: MUTEX;
      cnd_var: CONDITION_VARIABLE;
      p: PRODUCER;
      c: CONSUMER;
      i: INTEGER;
      msg: STRING;
    do
      !!msg.make(80);
      !!data.make;
      !!mtx.make;
      !!cnd_var.make;
      from
        i := 1
      until
        i > num_consumers
      loop
        msg.copy("Creating consumer ");
        msg.append(i.to_string);
        msg.append("...");
        print_line(msg);
        !!c.make(i,data,mtx,cnd_var);
        c.start;
        i := i + 1;
      end;
      from
        i := 1
      until
        i > num_producers
      loop
        msg.copy("Creating producer ");
        msg.append(i.to_string);
        msg.append(" ...");
        print_line(msg);
        !!p.make(i,num_items,data,mtx,cnd_var);
        p.start;
        i := i + 1;
      end;
      join_all -- wait until all producers & consumers terminate
    end;

end -- MAIN

