--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2001
--

class MAIN

inherit
  THREAD_CONTROL;
  THREAD_TERMINAL_HANDLER

creation
  make

feature

  num_iterations: INTEGER is 50;
  timer_period: INTEGER is 20; -- ms
  lines: ARRAY[INTEGER];
  columns: ARRAY[INTEGER];
  height: INTEGER is 10;
  width: INTEGER is 20;
  colors: ARRAY[INTEGER];
  attribs: ARRAY[INTEGER];
  timer: TIMER;

  make is
    local
      w: WINDOW;
      i: INTEGER;
    do
      initialize;
      lines := <<1,1,15,15>>;
      columns := <<1,40,1,40>>;
      colors := <<red_color_id,green_color_id,yellow_color_id,blue_color_id>>;
      attribs := <<bit_24_to_integer(normal_text_id),
                   bit_24_to_integer(highlight_id),
                   bit_24_to_integer(bold_id),
                   bit_24_to_integer(blinking_id)>>;
      !!timer.make;
      timer.set_period(timer_period);
      timer.start;
      from
        i := 1
      until
        i > 4
      loop
        !!w.make(lines @ i,columns @ i,height,width,num_iterations,
                 colors @ i,integer_to_bit_24(attribs @ i),
                 (('A').to_integer+i-1).to_character,timer);
        w.start;
        i := i + 1;
      end;
      join_all;
      set_cursor_position(number_of_lines,number_of_columns);
      terminate;
      timer.stop;
    end;

end -- MAIN

