--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2001
--

class WINDOW

inherit
  THREAD;
  THREAD_TERMINAL_HANDLER

creation
  make

feature {WINDOW}

  main is
    local
      i,l,c: INTEGER;
    do
      initialize;
      set_text_color(color);
      set_text_attributes(attr);
      set_cursor_position(line,column);
      from
        i := 1;
        l := line;
        c := column;
        timer.reset_lost_periods;
      until
        i > num_iterations
      loop
        timer.wait;
        write_char(chr);
        if c-column+1 = width then
          if l-line+1 = height then
            l := line
          else
            l := l + 1
          end;
          c := column;
          set_cursor_position(l,c)
        else
          c := c + 1;
        end;
        i := i + 1
      end;
      write_at(line + height - 1,column,timer.number_of_lost_periods.to_string);
      terminate;
    end;

feature

  make(l,c,h,w,n: INTEGER;cl: INTEGER;a: BIT 24;ch: CHARACTER;tmr: TIMER) is
    do
      line := l;
      column := c;
      height := h;
      width := w;
      num_iterations := n;
      color := cl;
      attr := a;
      chr := ch;
      timer := tmr;
    end;

  line: INTEGER;

  column: INTEGER;

  height: INTEGER;

  width: INTEGER;

  num_iterations: INTEGER;

  color: INTEGER;

  attr: BIT 24;

  chr: CHARACTER;

  timer: TIMER;

end -- WINDOW

