--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), May 2003
--

class MAIN

inherit
  X11_GLOBAL

creation
  make

feature

  make is
    local
      x11: X11_DISPLAY;
      w: X11_WINDOW;
      fnt1,fnt2,fnt3: X11_FONT;
      finish: BOOLEAN
    do
      !!x11.initialize;
      if x11.threads_usable then
        print_line("Threads usable!")
      else
        print_line("Threads not usable!")
      end;
      x11.open;
      print_line("Screen dimensions:");
      print_string("  Height: ");
      print_integer(x11.display_height_pixels);
      print_string(" pixels, ");
      print_integer(x11.display_height_mm);
      print_line(" mm");
      print_string("  Width: ");
      print_integer(x11.display_width_pixels);
      print_string(" pixels, ");
      print_integer(x11.display_width_mm);
      print_line(" mm");

      !!fnt1.make(x11);
      fnt1.load("-adobe-helvetica-*-r-*-*-24-*-*-*-*-*-iso8859-1");
      !!fnt2.make(x11);
      fnt2.load("fixed");
      !!fnt3.make(x11);
      fnt3.load("9x15");

      !!w.make(x11);
      w.set_coordinates(10,10,200,200);
      w.create_window(Void);
      w.define_cursor_from_shape(xcursor_man);
      w.select_input(button_press_mask or key_press_mask or exposure_mask);
      w.map_raised;
      from finish := false until finish loop
        x11.fetch_event;
        check x11.last_event_window = w end;
        inspect x11.last_event
          when event_expose then
            w.graphic_context.set_line_attributes(0,line_solid,cap_not_last,join_miter);
            w.add_point_to_draw(10,10);
            w.add_point_to_draw(10,90);
            w.add_point_to_draw(90,90);
            w.add_point_to_draw(90,10);
            w.draw_lines;
            w.add_segment_to_draw(0,0,100,100);
            w.add_segment_to_draw(0,100,100,0);
            w.draw_segments;
            w.draw_arc(30,30,40,40,0,360*64);
            w.add_arc_to_draw(30,30,40,40,0,360*64);
            w.fill_arcs;
            w.draw_string(100,100,"Hello (exit with Escape key)!");
            w.graphic_context.set_font(fnt1);
            w.draw_string(100,200,fnt1.name);
            w.graphic_context.set_font(fnt2);
            w.draw_string(100,250,fnt2.name);
            w.graphic_context.set_font(fnt3);
            w.draw_string(100,300,fnt3.name);
          when event_button_press then
          when event_key_press then
            if x11.key_sym = key_sym_escape then
              finish := true
            end;
          else
        end;
      end;
      w.destroy_window;
      x11.close;
      x11.terminate
    end;

end -- MAIN

