#!/bin/csh
#
#
# (C) Miguel Oliveira e Silva (mos@det.ua.pt)
#     August-November 2000
#     August 2002
#
# If it fails, try to re-install original SmallEiffel distribution
# and run this script (not doing 'make' on SmallEiffel root directory).
#

set se_dir=$SmallEiffel:h/..
set cur_dir=`pwd`

if (-rwx $se_dir) then
  if (-d $se_dir/lib/thread) then
    rm -rf $se_dir/lib/thread
  endif
  mkdir $se_dir/lib/thread
  if (-l current) then
    set prefixpth="current"
  else
    set prefixpth="."
  endif
  cp -a $prefixpth/ts_se/sys_runtime/* $se_dir/sys/runtime

  foreach f (`ls $prefixpth/ts_se/*.e`)
    set fn=`echo $f:t`
    set f_location=`find $se_dir/lib $se_dir/tools -name $fn`
    cp -a $f $f_location
  end

  cp -a $prefixpth/ts_se/lib/*.e $se_dir/lib/thread

    # check existance of read-write-locks and real-time extensions
  gcc -Werror -Wall -pthread -lrt check.c >& /dev/null
  if (! $status) then
    echo "Using new POSIX read-write-lock pthreads functions"
    rm -f a.out
    cp -a lib_thread/new_posix/*.e $se_dir/lib/thread
  else
    cp -a lib_thread/old_posix/*.e $se_dir/lib/thread
  endif
  cp -a lib_thread/*.e $se_dir/lib/thread

  cd $se_dir
  rm -rf bin
  mkdir bin
  make
  cd $cur_dir
  echo "done"
else
  echo "ERROR: No permissions to change SmallEiffel!"
endif

