-- This  file  is   free  software,  which   comes  along  with   thread-safe
-- SmallEiffel. This software  is distributed  in the  hope that  it will  be
-- useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
-- you want, provided this  header is kept unaltered,  and a notification  of
-- the changes is  added. You  are allowed to  redistribute it  and sell  it,
-- alone or as a part of another product.
--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2003
--
-- Based on ETL3
--

expanded class ONCE_MANAGER

feature

  refresh(key: STRING) is
    require
      key /= Void
    do
      c_reset_once_key(key.to_external)
    end;

  refresh_some(key_list: ARRAY[STRING]) is
    require
      key_list /= Void
    local
      i: INTEGER
    do
      from
        i := key_list.lower
      until
        i > key_list.upper
      loop
        refresh(key_list @ i);
        i := i + 1
      end
    end;

  refresh_all is
    do
      c_reset_all_once_keys
    end;

feature {NONE}

  c_reset_once_key(key: POINTER) is
    external "C"
    alias "_reset_once_key_"
    end;

  c_reset_all_once_keys is
    external "C"
    alias "_reset_all_once_keys_"
    end;

end -- ONCE_MANAGER

