-- This  file  is   free  software,  which   comes  along  with   thread-safe
-- SmallEiffel. This software  is distributed  in the  hope that  it will  be
-- useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
-- you want, provided this  header is kept unaltered,  and a notification  of
-- the changes is  added. You  are allowed to  redistribute it  and sell  it,
-- alone or as a part of another product.
--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August 2003
--

expanded class THREAD_ATTRIBUTE[T]

feature

  put(e: T) is
    local
      i: INTEGER
    do
      init_array;
      i := thread_index;
      value_list_rwl.read_lock;
      (value_list @ i).put(e);
      value_list_rwl.read_unlock
    end;

  item: T is
    local
      i: INTEGER
    do
      init_array;
      i := thread_index;
      value_list_rwl.read_lock;
      Result := (value_list @ i).item;
      value_list_rwl.read_unlock
    end;

feature {NONE}

  value_list_rwl: READ_WRITE_LOCK;

  value_list: ARRAY[SIMPLE_ATTRIBUTE[T]];

  init_array is
    once {"process","object"}
      !!value_list.with_capacity(8,1); -- empty array (8 threads by default)
      !!value_list_rwl.make_with_write_priority
    end

  thread_index: INTEGER is
    local
      sa: SIMPLE_ATTRIBUTE[T]
    once {"thread","object"}
      value_list_rwl.write_lock;
      !!sa;
      value_list.add_last(sa);
      Result := value_list.upper;
      value_list_rwl.write_unlock
    end

end -- THREAD_ATTRIBUTE

