-- This  file  is   free  software,  which   comes  along  with   thread-safe
-- SmallEiffel. This software  is distributed  in the  hope that  it will  be
-- useful, but WITHOUT  ANY WARRANTY; without  even the  implied warranty  of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. You can modify it  as
-- you want, provided this  header is kept unaltered,  and a notification  of
-- the changes is  added. You  are allowed to  redistribute it  and sell  it,
-- alone or as a part of another product.
--
-- (C) Miguel Oliveira e Silva (mos@det.ua.pt), August-October 2000
--
-- Class used for thread identification.
--
-- Thread identification is made on object creation (the id will be
-- the creating thread).
--

class THREAD_ID

inherit
  THREAD_CONTROL

creation
  make

feature

  make is
    do
      fetch_thread_data
    end;

  same_as(other: like Current): BOOLEAN is
    require
      other /= Void
    do
      Result := c_same_as(pthread_data,other.pthread_data)
    end;

feature {NONE}

  frozen c_same_as(td1,td2: POINTER): BOOLEAN is
    external "C"
    alias "same_thread_as"
    end;

end -- THREAD_ID

